#include<gtk-2.0/gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include<cairo.h>
#include<glib.h>
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"px_common.h"
#include"color.h"
#include"bmp_write.h"

#define NOW_APP_NAME "DOTY ver 1.0"

int cnvs_claer_full();
int px_draw_full();
create_tool_bar();

struct _DOT {
	int x;
	int y;
};

typedef struct _DOT DOT;

RGB_DOT *px_cnvs_vtl;
GtkWidget *drawing_area;//メインウィンドウ　ドローエリア
GtkWidget* statas_area;//ステータスバー
int dot_size=10;
int m_b_e=0;//マウス　ボタン　イベント
int now_tool=1;
int tool_line_start=FALSE;
int line_x,line_y;
int tool_box_start=FALSE;
int tool_circle_start=FALSE;
int box_x,box_y;
//int cur_on=FALSE;
int cur_on=TRUE;
char *now_file_name[1024];
GtkWidget	*change_dialog;
GtkWidget	*change_scale_dialog;
GtkWidget	*entry_width;
GtkWidget	*entry_height;
GtkWidget	*entry_size;
int mv_size_widht=64;//メインビュウ　サイズ
int mv_size_heigth=64;//メインビュウ　サイズ
int now_window_top;
int now_window_bottom;
int now_window_left;
int now_window_right;
GtkWidget	*g_scroll_window;
GtkWidget* window;

int yesno_dialog(){
  GtkWidget	*dialog;
  GtkWidget	*parent;
  GtkWidget	*label;
  gint		response;
  char str[1024];
  
  parent = GTK_WIDGET(px_main_window);

  dialog = gtk_dialog_new_with_buttons ("",
					GTK_WINDOW(parent),
					GTK_DIALOG_MODAL |
					GTK_DIALOG_DESTROY_WITH_PARENT,
					GTK_STOCK_NO, GTK_RESPONSE_NO,
					GTK_STOCK_YES, GTK_RESPONSE_YES,
					NULL);
  sprintf(str," \"%s\"\nで変更した内容を閉じる前に保存しますか？",now_file_name);
  label = gtk_label_new (str);
  gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
  gtk_widget_set_size_request (dialog, 550, 100);  
  gtk_widget_show_all (dialog);
  response = gtk_dialog_run (GTK_DIALOG(dialog));
 
  if (response == GTK_RESPONSE_YES) {
 	save();
    g_print ("Yes button was pressed.\n");
	gtk_widget_destroy (dialog);
   
  } else if (response == GTK_RESPONSE_NO) {
	gtk_widget_destroy (dialog);
    g_print ("No button was pressed.\n");    
  } else {
    g_print ("Another response was recieved.\n");    
	gtk_widget_destroy (dialog);
  }
}

static void
cb_change_button(GtkAction *action, gpointer user_data){
gchar *gstr;
char str[1024];
gstr=gtk_entry_get_text(entry_width);
mv_size_widht=atoi(gstr);

gstr=gtk_entry_get_text(entry_height);
mv_size_heigth=atoi(gstr);


g_free(px_cnvs);
g_free(px_cnvs_vtl);

px_cnvs= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
if(px_cnvs==NULL)printf("error\n");
px_cnvs_vtl= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
if(px_cnvs_vtl==NULL)printf("error\n");


g_print("change!!\n");
//if (save_fg==TRUE){yesno_dialog();}
gtk_widget_set_size_request(drawing_area,dot_size*mv_size_widht,dot_size*mv_size_heigth);
gdk_window_clear(drawing_area->window);
cnvs_claer_full();
px_draw_full();
 
strcpy(now_file_name,"無題.doty");
strcpy(str,NOW_APP_NAME);
strcat(str,":");
strcat(str,now_file_name);

char w_str[1024];
sprintf(w_str,"  ( %d x %d )",mv_size_widht,mv_size_heigth);
strcat(str,w_str);
gtk_window_set_title(GTK_WINDOW(px_main_window),str);
save_fg=FALSE;




g_print("cb_change_button\n");
gtk_widget_destroy (change_dialog);
}


static void
//cb_change(GtkAction *action, gpointer user_data){
cb_change(){
	GtkWidget	*parent;
	GtkWidget	*hbox;
	GtkWidget	*label;
	GtkWidget	*button;
	gint		response;
	char str[1024];

	parent = GTK_WIDGET(px_main_window);

	change_dialog = gtk_dialog_new();

	hbox = gtk_hbox_new(FALSE,5);	

	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(change_dialog)->vbox),hbox);

	label = gtk_label_new("横：");
	
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);

	entry_width = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),entry_width,TRUE,TRUE,0);
	sprintf(str,"%d",mv_size_widht);
	gtk_entry_set_text(entry_width,str);	
	


	hbox = gtk_hbox_new(FALSE,5);	

	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(change_dialog)->vbox),hbox);

	label = gtk_label_new("縦：");
	
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);

	entry_height = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),entry_height,TRUE,TRUE,0);
	
	sprintf(str,"%d",mv_size_heigth);
	gtk_entry_set_text(entry_height,str);	
	
	button = gtk_button_new_from_stock(GTK_STOCK_APPLY);
	g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(cb_change_button),NULL);
	/*gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),button,TRUE,TRUE,0);*/
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(change_dialog)->action_area),button,TRUE,TRUE,0);

	gtk_widget_show_all(change_dialog);
		
	response = gtk_dialog_run (GTK_DIALOG(change_dialog));
printf("cb_change5\n");
}


cb_size_change_button(){

	gchar *gstr;
	gstr=gtk_entry_get_text(entry_size);
	dot_size=atoi(gstr);
	if (dot_size>10)dot_size=10;
	if (dot_size<2)dot_size=2;

	gtk_widget_destroy (change_scale_dialog);
	gtk_widget_destroy(window);
	
	crate_main_window();
printf("size change:%d",dot_size);	
}

cb_change_scale(){
	GtkWidget	*parent;
	GtkWidget	*hbox;
	GtkWidget	*label;
	GtkWidget	*button;
	gint		response;
	char str[1024];

	parent = GTK_WIDGET(px_main_window);

	change_scale_dialog = gtk_dialog_new();

	hbox = gtk_hbox_new(FALSE,5);	

	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(change_scale_dialog)->vbox),hbox);

	label = gtk_label_new("スケール（２−１０）：");
	
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);

	entry_size = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),entry_size,TRUE,TRUE,0);
	sprintf(str,"%d",dot_size);
	gtk_entry_set_text(entry_size,str);	
	
	
	button = gtk_button_new_from_stock(GTK_STOCK_APPLY);
	g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(cb_size_change_button),NULL);
	/*gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),button,TRUE,TRUE,0);*/
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(change_scale_dialog)->action_area),button,TRUE,TRUE,0);

	gtk_widget_show_all(change_scale_dialog);
		
	response = gtk_dialog_run (GTK_DIALOG(change_scale_dialog));

}


static void
cb_new(GtkAction *action, gpointer user_data){
	char str[1024];
	g_print("newnew!!\n");
	if (save_fg==TRUE){yesno_dialog();}
	gdk_window_clear(drawing_area->window);





cb_change();





/*	cnvs_claer_full();
	px_draw_full();
	strcpy(now_file_name,"無題.doty");
	strcpy(str,NOW_APP_NAME);
	strcat(str,":");
	strcat(str,now_file_name);
	gtk_window_set_title(GTK_WINDOW(px_main_window),str);*/
	save_fg=FALSE;
}

int px_open(char* filename){
		FILE *fp;
		char str[1024];
		int x,y;
		RGB_DOT w_rgb;
		fp=fopen(filename,"r");
		fgets(str,1024,fp);
		
		if (strcmp(str,"doty1.0\n")!=0){px_error("error... DOTYのファイルではありません。");goto open_error;}
		
		//fgets(str,1024,fp);
		fscanf(fp,"%d x %d\n",&mv_size_widht,&mv_size_heigth);
g_print("%d,%d",mv_size_widht,mv_size_heigth);
		gtk_widget_set_size_request(drawing_area,dot_size*mv_size_widht,dot_size*mv_size_heigth);

		g_free(px_cnvs);
		g_free(px_cnvs_vtl);

		px_cnvs= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
		if(px_cnvs==NULL)printf("error\n");
		px_cnvs_vtl= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
		if(px_cnvs_vtl==NULL)printf("error\n");

		cnvs_claer_full();
		y=0;
		while(y<mv_size_heigth){
			x=0;
			while(x<mv_size_widht){
				fscanf(fp,"%d,%d,%d\n", &(w_rgb.r) , &(w_rgb.g) , &(w_rgb.b));
				px_dot(px_cnvs, x, y, w_rgb.r, w_rgb.g, w_rgb.b);	
				x++;
			}
			y++;	
		}
		save_fg=FALSE;
		gdk_window_clear(drawing_area->window);
		px_draw_full();
		//px_draw_full();
		//px_draw_full();
		//px_draw_full();
		strcpy(now_file_name,filename);
		strcpy(str,"DOTY ver 1.0");
		strcat(str,":");
		strcat(str,now_file_name);
		char w_str[1024];
		sprintf(w_str,"  ( %d x %d )",mv_size_widht,mv_size_heigth);
		strcat(str,w_str);
		gtk_window_set_title(GTK_WINDOW(px_main_window),str);
open_error:
		fclose(fp);
}

static void
cb_open(GtkAction *action, gpointer user_data){
	g_print("open!!\n");
	GtkWidget* dialog;
	gint response;
	if (save_fg==TRUE){yesno_dialog();}
	dialog= gtk_file_chooser_dialog_new("開く",
										GTK_WINDOW(px_main_window),
										GTK_FILE_CHOOSER_ACTION_OPEN,
										GTK_STOCK_CANCEL,
										GTK_RESPONSE_CANCEL,
										GTK_STOCK_OPEN,
										GTK_RESPONSE_ACCEPT,
										NULL);
	gtk_widget_show_all(dialog);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if(response==GTK_RESPONSE_ACCEPT){
		gchar *filename;
		
		filename= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
g_print("menu open:%s\n",filename);		
	
		px_open(filename);

		g_free(filename);
	}
	gtk_widget_destroy(dialog);
	
}

int save(){
	g_print("save!!\n");
	FILE *fp;
	char str[1024];
	int x,y;
	RGB_DOT w_rgb;
	fp=fopen(now_file_name,"w");
	fputs("doty1.0\n",fp);
	sprintf(str,"%d x %d\n",mv_size_widht,mv_size_heigth);
	fputs(str,fp);
	y=0;
	while(y<mv_size_heigth){
		x=0;
		while(x<mv_size_widht){
			px_get_dot(px_cnvs, x, y, &w_rgb);	
			sprintf(str,"%d,%d,%d\n",w_rgb.r , w_rgb.g , w_rgb.b);
			fputs(str,fp);
			x++;
		}
		y++;	
	}
	fclose(fp);
	return TRUE;
}

static void
cb_save(GtkAction *action, gpointer user_data){
	save();
	save_fg=FALSE;

}
static void
cb_saveas(GtkAction *action, gpointer user_data){
	g_print("saveas!!\n");
	GtkWidget* dialog;
	gint response;
	
	dialog= gtk_file_chooser_dialog_new("名前を付けて保存",
										GTK_WINDOW(px_main_window),
										GTK_FILE_CHOOSER_ACTION_SAVE,
										GTK_STOCK_CANCEL,
										GTK_RESPONSE_CANCEL,
										GTK_STOCK_SAVE_AS,
										GTK_RESPONSE_ACCEPT,
										NULL);
	gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dialog),TRUE);
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(dialog), now_file_name);
	gtk_widget_show_all(dialog);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if(response==GTK_RESPONSE_ACCEPT){
		gchar *filename;
		
		filename= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
g_print("menu save as:%s\n",filename);		
		FILE *fp;
		char str[1024];
		int x,y;
		RGB_DOT w_rgb;
		fp=fopen(filename,"w");
		fputs("doty1.0\n",fp);
		sprintf(str,"%d x %d\n",mv_size_widht,mv_size_heigth);
		fputs(str,fp);
		y=0;
		while(y<mv_size_heigth){
			x=0;
			while(x<mv_size_widht){
				px_get_dot(px_cnvs, x, y, &w_rgb);	
				sprintf(str,"%d,%d,%d\n",w_rgb.r , w_rgb.g , w_rgb.b);
				fputs(str,fp);
				x++;
			}
			y++;	
		}
		fclose(fp);
		strcpy(now_file_name,filename);
		strcpy(str,NOW_APP_NAME);
		strcat(str,":");
		strcat(str,now_file_name);
		gtk_window_set_title(GTK_WINDOW(px_main_window),str);
		save_fg=FALSE;
		g_free(filename);
	}
	gtk_widget_destroy(dialog);
}

unsigned int* doty2int32(RGB_DOT* buf){
		int x,y,n;
		RGB_DOT w_rgb;
		unsigned int* tobuf;
		tobuf=g_malloc(sizeof(unsigned int)*mv_size_heigth*mv_size_widht);
		if(tobuf==NULL)printf("error doty2int32\n");
		y=0;
		n=0;
		while(y<mv_size_heigth){
			x=0;
			while(x<mv_size_widht){
				px_get_dot(buf, x, y, &w_rgb);	
				tobuf[n]=w_rgb.r*256*256 + w_rgb.g*256 + w_rgb.b;
g_print("%d\n",tobuf[n]);			
				n++;
				x++;
			}
			y++;
		}
		return tobuf;
}

static void
cb_export_bmp(GtkAction *action, gpointer user_data){
	g_print("export_bmp!!\n");
	GtkWidget* dialog;
	gint response;
	
	dialog= gtk_file_chooser_dialog_new("エクスポート BMP",
										GTK_WINDOW(px_main_window),
										GTK_FILE_CHOOSER_ACTION_SAVE,
										GTK_STOCK_CANCEL,
										GTK_RESPONSE_CANCEL,
										GTK_STOCK_SAVE_AS,
										GTK_RESPONSE_ACCEPT,
										NULL);
	gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dialog),TRUE);
	char str[1024];
	strcpy(str,now_file_name);
	int l=strlen(str);
g_print("l=%d\n",l);	
	while (l>=0){if(str[l]=='.') break; else l--;}
g_print("l=%d\n",l);	
	str[l]=0;
g_print("\n%s\n",str);
	strcat(str,".bmp");
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(dialog), str);
	gtk_widget_show_all(dialog);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if(response==GTK_RESPONSE_ACCEPT){
		gchar *filename;
		unsigned int *tobuf;
		
		filename= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
g_print("menu export:%s\n",filename);		
		tobuf=doty2int32(px_cnvs);
g_print("bmp_write\n");
		bmp_write(filename,mv_size_widht,mv_size_heigth ,tobuf);
	}
g_print("bmp_write6\n");
	gtk_widget_destroy(dialog);
}

static void
cb_export_png(GtkAction *action, gpointer user_data){
	g_print("export_png!!\n");
	GtkWidget* dialog;
	gint response;
	
	dialog= gtk_file_chooser_dialog_new("エクスポート PNG",
										GTK_WINDOW(px_main_window),
										GTK_FILE_CHOOSER_ACTION_SAVE,
										GTK_STOCK_CANCEL,
										GTK_RESPONSE_CANCEL,
										GTK_STOCK_SAVE_AS,
										GTK_RESPONSE_ACCEPT,
										NULL);
	gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dialog),TRUE);
	char str[1024];
	strcpy(str,now_file_name);
	int l=strlen(str);
g_print("l=%d\n",l);	
	while (l>=0){if(str[l]=='.') break; else l--;}
g_print("l=%d\n",l);	
	str[l]=0;
g_print("\n%s\n",str);
	strcat(str,".png");
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(dialog), str);
	gtk_widget_show_all(dialog);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if(response==GTK_RESPONSE_ACCEPT){
		gchar *filename;
		unsigned int *tobuf;
		
		filename= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
g_print("menu export:%s\n",filename);		
		tobuf=doty2int32(px_cnvs);
g_print("bmp_write\n");
		bmp_write( ".px_tmp100001.bmp",mv_size_widht,mv_size_heigth ,tobuf);
		GdkPixbuf *pixbuf=gdk_pixbuf_new_from_file(".px_tmp100001.bmp",NULL);
		gdk_pixbuf_save(pixbuf,filename,"png",NULL,NULL);
		
	}
g_print("png_write6\n");
	gtk_widget_destroy(dialog);
}

static void
cb_export_jpeg(GtkAction *action, gpointer user_data){
	g_print("export_jpeg!!\n");
	GtkWidget* dialog;
	gint response;
	
	dialog= gtk_file_chooser_dialog_new("エクスポート JPEG",
										GTK_WINDOW(px_main_window),
										GTK_FILE_CHOOSER_ACTION_SAVE,
										GTK_STOCK_CANCEL,
										GTK_RESPONSE_CANCEL,
										GTK_STOCK_SAVE_AS,
										GTK_RESPONSE_ACCEPT,
										NULL);
	gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(dialog),TRUE);
	char str[1024];
	strcpy(str,now_file_name);
	int l=strlen(str);
g_print("l=%d\n",l);	
	while (l>=0){if(str[l]=='.') break; else l--;}
g_print("l=%d\n",l);	
	str[l]=0;
g_print("\n%s\n",str);
	strcat(str,".jpeg");
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(dialog), str);
	gtk_widget_show_all(dialog);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if(response==GTK_RESPONSE_ACCEPT){
		gchar *filename;
		unsigned int *tobuf;
		
		filename= gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
g_print("menu export:%s\n",filename);		
		tobuf=doty2int32(px_cnvs);
g_print("bmp_write\n");
		bmp_write( ".px_tmp100001.bmp",mv_size_widht,mv_size_heigth ,tobuf);
		GdkPixbuf *pixbuf=gdk_pixbuf_new_from_file(".px_tmp100001.bmp",NULL);
		gdk_pixbuf_save(pixbuf,filename,"jpeg",NULL,NULL);
		
	}
g_print("jpeg_write6\n");
	gtk_widget_destroy(dialog);
}

int tool_clear(){
	tool_line_start = FALSE;
	tool_box_start = FALSE;
}

static void
cb_spoit(GtkAction *action, gpointer user_data){
	now_tool=9;
	px_draw_full();
}

static void
cb_dot(GtkAction *action, gpointer user_data){
	g_print("menu dot\n");
	tool_clear();
	now_tool=1;
}

static void
cb_line(GtkAction *action, gpointer user_data){
	g_print("menu line\n");
	tool_clear();
	now_tool=2;
}

static void
cb_box(GtkAction *action, gpointer user_data){
	g_print("menu box\n");
	tool_clear();
	now_tool=3;
}

static void
cb_box2(GtkAction *action, gpointer user_data){
	g_print("menu box2\n");
	tool_clear();
	now_tool=4;
}

static void
cb_circle(GtkAction *action, gpointer user_data){
	g_print("menu circle\n");
	tool_clear();
	now_tool=5;
}

static void
cb_circle2(GtkAction *action, gpointer user_data){
	g_print("menu circle2\n");
	tool_clear();
	now_tool=6;
}

static void
cb_paint(GtkAction *action, gpointer user_data){
	g_print("menu paint\n");
	tool_clear();
	now_tool=7;
}

static void
cb_quit(GtkAction *action, gpointer user_data){
	if (save_fg==TRUE){yesno_dialog();}
	gtk_main_quit();
	//gtk_widget_destroy(px_main_window);
	g_print("quit\n");
}

static void
active_tool_bar(GtkAction *action, gpointer user_data){
	if (tool_bar_view_fg==FALSE){create_tool_bar();tool_bar_view_fg=TRUE;}
	/*gtk_widget_set_child_visible  (px_main_window,TRUE);
	gtk_widget_set_child_visible  (px_main_window,TRUE);*/
	
}
static void
active_color_palet(GtkAction *action, gpointer user_data){
if (color_paret_view_fg==FALSE){create_color_palet();color_paret_view_fg=TRUE;}
	/*gtk_widget_set_child_visible  (cp_main_window,TRUE);
	gtk_widget_set_child_visible  (tool_bar_window,TRUE);*/
	
}
static void
active_preview(GtkAction *action, gpointer user_data){
if (preview_fg==FALSE){preview();preview_fg=TRUE;}
	/*gtk_widget_set_child_visible  (cp_main_window,TRUE);
	gtk_widget_set_child_visible  (tool_bar_window,TRUE);*/
	
}
static GtkWidget* create_menu (void) {
  GtkWidget	*menubar;
  GtkWidget	*menu;	
  GtkWidget	*item;
  GtkWidget	*image;
  GtkAccelGroup	*accel_group;
  GSList	*group = NULL;
  
  menubar = gtk_menu_bar_new ();
  accel_group = gtk_accel_group_new ();  
  
  item = gtk_menu_item_new_with_mnemonic ("ファイル(_F)");
  gtk_container_add (GTK_CONTAINER(menubar), item);
  menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
  {
    item = gtk_tearoff_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);
    
    item = gtk_menu_item_new_with_mnemonic ("新規(_N)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_N, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_new), NULL);

   item = gtk_menu_item_new_with_mnemonic ("開く(_O)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_open), NULL);

    item = gtk_menu_item_new_with_mnemonic ("保存(_S)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_S, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_save), NULL);

    item = gtk_menu_item_new_with_mnemonic ("名前を付けて保存(_A)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_S, GDK_CONTROL_MASK | GDK_SHIFT_MASK,
				GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_saveas), NULL);

/*     item = gtk_menu_item_new_with_mnemonic ("キャンバスのサイズを変更する(_C)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_G, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_change), NULL);*/

    item = gtk_image_menu_item_new_with_label ("エクスポート(_E)");
    image = gtk_image_new_from_stock (GTK_STOCK_SORT_ASCENDING,
				      GTK_ICON_SIZE_MENU);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM(item), image);
    gtk_container_add (GTK_CONTAINER(menu), item);
  {
    GtkWidget	*menu;	
    menu = gtk_menu_new ();

    gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
    {
     item = gtk_menu_item_new_with_mnemonic ("BMPファイルとして保存(_B)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_S, GDK_CONTROL_MASK | GDK_SHIFT_MASK,
				GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_export_bmp), NULL);

     item = gtk_menu_item_new_with_mnemonic ("PNGファイルとして保存(_P)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_S, GDK_CONTROL_MASK | GDK_SHIFT_MASK,
				GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_export_png), NULL);

      item = gtk_menu_item_new_with_mnemonic ("JPEGファイルとして保存(_J)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_S, GDK_CONTROL_MASK | GDK_SHIFT_MASK,
				GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_export_jpeg), NULL);

 /*   item = gtk_radio_menu_item_new_with_label (group, "ｂｍｐファイルとして保存");
      gtk_container_add (GTK_CONTAINER(menu), item);
      gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM(item), TRUE);

      group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM(item));
      item = gtk_radio_menu_item_new_with_label (group, "File size");
      gtk_container_add (GTK_CONTAINER(menu), item);

      group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM(item));
      item = gtk_radio_menu_item_new_with_label (group, "Update time");
      gtk_container_add (GTK_CONTAINER(menu), item);*/
    }
   }
    item = gtk_separator_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_menu_item_new_with_mnemonic ("終了(_Q)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_quit), NULL);
  
  }
  item = gtk_menu_item_new_with_mnemonic ("編集(_E)");
  gtk_container_add (GTK_CONTAINER(menubar), item);
  menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
  {
    item = gtk_tearoff_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);
    
    item = gtk_menu_item_new_with_mnemonic ("取り消す(_U)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_Z, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	
    item = gtk_menu_item_new_with_mnemonic ("やり直す(_R)");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_Z, GDK_CONTROL_MASK | GDK_SHIFT_MASK, GTK_ACCEL_VISIBLE);
	
    /*item = gtk_image_menu_item_new_from_stock (GTK_STOCK_CUT, accel_group);
    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_image_menu_item_new_from_stock (GTK_STOCK_COPY, accel_group);
    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_image_menu_item_new_from_stock (GTK_STOCK_PASTE, accel_group);
    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_image_menu_item_new_from_stock (GTK_STOCK_DELETE, accel_group);
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_D, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);*/
  }
  item = gtk_menu_item_new_with_mnemonic ("ツール(_T)");
  gtk_container_add (GTK_CONTAINER(menubar), item);
  menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
  {
    item = gtk_tearoff_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);
     
    item = gtk_menu_item_new_with_mnemonic ("スポイト");
    gtk_container_add (GTK_CONTAINER(menu), item);
     g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_spoit), NULL);
  
    item = gtk_menu_item_new_with_mnemonic ("点");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				NULL, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_dot), NULL);

    item = gtk_menu_item_new_with_mnemonic ("線");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_line), NULL);

    item = gtk_menu_item_new_with_mnemonic ("正方形");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_S, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_box), NULL);

    item = gtk_menu_item_new_with_mnemonic ("長方形");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_S, GDK_CONTROL_MASK | GDK_SHIFT_MASK,
//				GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_box2), NULL);

//    item = gtk_separator_menu_item_new ();
//    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_menu_item_new_with_mnemonic ("円");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_circle), NULL);

    item = gtk_menu_item_new_with_mnemonic ("楕円");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_circle2), NULL);

    item = gtk_menu_item_new_with_mnemonic ("塗り");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_paint), NULL);
  }  
  item = gtk_menu_item_new_with_mnemonic ("表示(_V)");
  gtk_container_add (GTK_CONTAINER(menubar), item);
  menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
  {
    item = gtk_tearoff_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);
    
    item = gtk_menu_item_new_with_mnemonic ("スケールの変更");
    gtk_container_add (GTK_CONTAINER(menu), item);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(cb_change_scale), NULL);

    item = gtk_menu_item_new_with_mnemonic ("ツールバー");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				NULL, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(active_tool_bar), NULL);

    item = gtk_menu_item_new_with_mnemonic ("カラーパレット");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(active_color_palet), NULL);
 
    item = gtk_menu_item_new_with_mnemonic ("プレビュー");
    gtk_container_add (GTK_CONTAINER(menu), item);
//    gtk_widget_add_accelerator (item, "activate", accel_group,
//				GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
    g_signal_connect (G_OBJECT(item), "activate", G_CALLBACK(active_preview), NULL);
 } 
/*  item = gtk_menu_item_new_with_mnemonic ("View２");
  gtk_container_add (GTK_CONTAINER(menubar), item);
  menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
  {
    item = gtk_tearoff_menu_item_new ();
    gtk_container_add (GTK_CONTAINER(menu), item);

    item = gtk_check_menu_item_new_with_label ("Show Hidden Folders");
    gtk_container_add (GTK_CONTAINER(menu), item);
    gtk_widget_add_accelerator (item, "activate", accel_group,
				GDK_H, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

    item = gtk_image_menu_item_new_with_label ("Sort by ...");
    image = gtk_image_new_from_stock (GTK_STOCK_SORT_ASCENDING,
				      GTK_ICON_SIZE_MENU);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM(item), image);
    gtk_container_add (GTK_CONTAINER(menu), item);
    menu = gtk_menu_new ();
    gtk_menu_item_set_submenu (GTK_MENU_ITEM(item), menu);
    {
      item = gtk_radio_menu_item_new_with_label (group, "File type");
      gtk_container_add (GTK_CONTAINER(menu), item);
      gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM(item), TRUE);

      group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM(item));
      item = gtk_radio_menu_item_new_with_label (group, "File size");
      gtk_container_add (GTK_CONTAINER(menu), item);

      group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM(item));
      item = gtk_radio_menu_item_new_with_label (group, "Update time");
      gtk_container_add (GTK_CONTAINER(menu), item);
    }
  }*/
  return menubar;
}
		


//============================================================================================================
//toolbar
//-------------------------------------------------------------------------------------------------------------

gint tool_bar_delete_event(GtkWidget* widget,GdkEvent* event, gpointer data){
	g_print("tool bar delete_event \n");
	tool_bar_view_fg=FALSE;
	return FALSE;
}
static void 
btn_dot(){
	g_print("dot\n");
	tool_clear();
	now_tool=1;
}
static void 
btn_line(){
	g_print("line\n");
	tool_clear();
	now_tool=2;
}
static void 
btn_box(){
	g_print("box\n");
	tool_clear();
	now_tool=3;
}
static void 
btn_box2(){
	g_print("box2\n");
	tool_clear();
	now_tool=4;
}
static void 
btn_carcle(){
	g_print("carcle\n");
	tool_clear();
	now_tool=5;
}
static void 
btn_carcle2(){
	g_print("carcle2\n");
	tool_clear();
	now_tool=6;
}
static void 
btn_paint(){
	g_print("paint\n");
	tool_clear();
	now_tool=7;
}

static void 
btn_crear(){
	g_print("crear\n");
	tool_clear();
	now_tool=8;
	cnvs_claer_full();
	px_draw_full();
	//px_draw_full();
	//px_draw_full();
	//px_draw_full();
	return;
}

static void 
btn_spoit(){
	g_print("spoit\n");
	now_tool=9;
	px_draw_full();
	return;
}


int create_tool_bar(){
	tool_bar_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *image;

	gtk_window_set_title(GTK_WINDOW(tool_bar_window),"TOOL");
	gtk_window_set_default_size(GTK_WINDOW(tool_bar_window),140,700);
	gtk_window_set_position(GTK_WINDOW(tool_bar_window),GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_signal_connect(GTK_OBJECT(tool_bar_window),"delete_event",GTK_SIGNAL_FUNC(tool_bar_delete_event),NULL);
	
	vbox=gtk_vbox_new(TRUE,0);
	gtk_container_add(GTK_CONTAINER(tool_bar_window),vbox);

/*	button=gtk_button_new_with_label("範囲");
//	button=gtk_button_new();
//GtkWidget * image=gtk_image_new_from_file ("./uso.png");
//gtk_button_set_image ((GtkButton*)button,image);
//gtk_button_set_image_position ((GtkButton*)button,GTK_POS_LEFT);
//	gtk_button_set_label ((GtkButton*)button,"範囲");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);	
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_dot), NULL);

	button=gtk_button_new_with_label("自由範囲");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);	
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_dot), NULL);*/

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./supoit.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("スポイト");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);	
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_spoit), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./dot.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("点");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);	
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_dot), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./line.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("線");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_line), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./box.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("正方形");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_box), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./box2.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("長方形");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_box2), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./maru.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("円");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_carcle), NULL);

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./maru2.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("楕円");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_carcle2), NULL);

/*	button=gtk_button_new_with_label("拡大");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_carcle2), NULL);

	button=gtk_button_new_with_label("縮小");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_carcle2), NULL);

	button=gtk_button_new_with_label("回転");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_carcle2), NULL);*/

	button=gtk_button_new();
	image=gtk_image_new_from_file ("./nuri.png");
	gtk_button_set_image ((GtkButton*)button,image);
//	button=gtk_button_new_with_label("塗り");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_paint), NULL);

/*	button=gtk_button_new_with_label("クリア");
	gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
	g_signal_connect (G_OBJECT (button),"clicked",G_CALLBACK (btn_crear), NULL);*/

	gtk_widget_show_all(tool_bar_window);
}
//------------------------------------------------------------------------------------------------------------
//end tool bar
//============================================================================================================


int px_old_x=0;
int px_old_y=0;
int tz=0;


int px_draw_pix(cairo_t *cr,double x,double y,double r,double g,double b){
	cairo_set_line_width(cr,1.0);
	cairo_set_source_rgb(cr,((double)r)/256.0,((double)g)/256.0,((double)b)/256.0);
	cairo_move_to(cr,x,y);
	cairo_line_to(cr,x+0.5219,y+0.5219);
	cairo_stroke(cr);
}

int px_draw_box(cairo_t *cr,double x,double y,double x2,double y2,int r,int g,int b){
	cairo_set_line_width(cr,1.0);
	cairo_set_source_rgb(cr,((double)r/256.0),((double)g/256.0),((double)b/256.0));
	
	cairo_move_to(cr,x,y);
	cairo_line_to(cr,x2+0.5219,y+0.5219);

	cairo_move_to(cr,x2,y);
	cairo_line_to(cr,x2+0.5219,y2+0.5219);

	cairo_move_to(cr,x2,y2);
	cairo_line_to(cr,x+0.5219,y2+0.5219);

	cairo_move_to(cr,x,y2);
	cairo_line_to(cr,x+0.5219,y+0.5219);

	cairo_stroke(cr);
	
}

int get_l(int p1,int p2){
	if (p1>p2) return p1-p2; else return p2-p1;
}

int get_l_z(int p1,int p2){
	if (p1>p2) return (p1-p2)*-1; else return p2-p1;
}

int px_dot(RGB_DOT* px_cnvs,int x,int y,int r,int g,int b){
	cairo_t *cr;

	if (x<0 || x>=mv_size_widht || y<0 || y>=mv_size_heigth) {
		return FALSE;
	}
	
	px_cnvs[y*mv_size_widht+x].r=r;
	px_cnvs[y*mv_size_widht+x].g=g;
	px_cnvs[y*mv_size_widht+x].b=b;
	
	if(x<now_window_left)return FALSE;
	if(x>now_window_right)return FALSE;
	if(y<now_window_top)return FALSE;
	if(y>now_window_bottom)return FALSE;
	
	cr = gdk_cairo_create(drawing_area->window);

	px_draw_box(cr,(x*dot_size),
					(y*dot_size),
					(x*dot_size+dot_size-1),
					(y*dot_size+dot_size-1),
					r,g,b);
/*	px_draw_box(cr,(x*dot_size+1),
					(y*dot_size+1),
					(x*dot_size+dot_size-2),
					(y*dot_size+dot_size-2),
					r,g,b);
	px_draw_box(cr,(x*dot_size+2),
					(y*dot_size+2),
					(x*dot_size+dot_size-3),
					(y*dot_size+dot_size-3),
					r,g,b);*/
	//px_draw_pix(cr,(int)(dot_size/2+x*dot_size),(int)(dot_size/2+y*dot_size),0,0,0);

	cairo_stroke(cr);
	cairo_destroy(cr);
}

int px_get_dot(RGB_DOT* px_cnvs,int x,int y,RGB_DOT *get_rgb){
	if(x<0 || y<0 || x >= mv_size_widht || y >= mv_size_heigth){//error
		get_rgb->r=-1;
		get_rgb->g=-1;
		get_rgb->b=-1;
		return FALSE;
	}
	get_rgb->r=px_cnvs[y*mv_size_widht+x].r;
	get_rgb->g=px_cnvs[y*mv_size_widht+x].g;
	get_rgb->b=px_cnvs[y*mv_size_widht+x].b;
	return TRUE;
}

int px_line(RGB_DOT* px_cnvs,int x1,int y1,int x2,int y2,int r,int g,int b){
	double widht,heigth;
	double t;
	double xvct;
	
	if(y1>y2){
		int w;
		w =x1;
		x1=x2;
		x2=w;
 		w =y1;
		y1=y2;
		y2=w;
	}//       /\

	if(x2==x1)widht=0;
	if(x2>x1)widht=x2-x1;else widht=x1-x2;
	if(y2==y1)heigth=0.0000001;else heigth=y2-y1;
	
	if(x2>=x1)xvct=1;else xvct=-1;
	
	if(widht>=heigth){
		double w_x,w_y;
		int n=0;
//		t=(heigth+1)/(widht+1);//横のほうが長い
		t=heigth/widht;//横のほうが長い
		//px_dot(px_cnvs,((int)x1),((int)y1),r,g,b);
		//t=t*(double)xvct;
		while((int)n<=(int)widht){
			w_x=(double)x1+(double)n*(double)xvct;
			w_y=(double)y1+(double)n*t;
//			w_y=(double)w_x*t;
			px_dot(px_cnvs,(int)w_x,(int)w_y,r,g,b);
			n++;
		}
		//px_dot(px_cnvs,((int)w_x),((int)w_y),r,g,b);
		
	}else{
		double w_x,w_y;
		int n=0;
//		t=(widht+1)/(heigth+1);//縦のほうが長い
		t=widht/heigth;//縦のほうが長い
		//t=t*(double)xvct;
//		px_dot(px_cnvs,((int)x1),((int)y1),r,g,b);
		while((int)n<=(int)heigth){
			w_y=(double)y1+(double)n;
//			w_x=w_y*(double)t*(double)xvct;
			w_x=(double)x1+(double)n*(double)t*(double)xvct;
			px_dot(px_cnvs,(int)w_x,(int)w_y,r,g,b);
			n++;
		}
		//px_dot(px_cnvs,((int)w_x),((int)w_y),r,g,b);
	}
	//px_dot(px_cnvs,((int)x2),((int)y2),r,g,b);
	
}

int px_box(RGB_DOT* px_cnvs,int x1,int y1,int x2,int y2,int r,int g,int b){
	
	px_line(px_cnvs,x1,y1,x2,y1,r,g,b);
	px_line(px_cnvs,x2,y1,x2,y2,r,g,b);
	px_line(px_cnvs,x2,y2,x1,y2,r,g,b);
	px_line(px_cnvs,x1,y2,x1,y1,r,g,b);
	
}

int px_circle(RGB_DOT* px_cnvs,int x1,int y1,int x2,int y2,int r,int g,int b){
	double la,lb;
	la=(double)get_l(x1,x2);
	lb=(double)get_l(y1,y2);
g_print("circle la:%lf,lb:%lf , x1:%d , x2:%d , y1:%d , y2:%d\n",la,lb,x1,x2,y1,y2);
	if (la < lb){
		//横に長い
		double w_x,w_y;
		w_x=0.4;
		while(w_x < la){
			RGB_DOT w_rgb;
			w_y = (lb/la) * sqrt( (pow(la,2.0)-pow(w_x,2.0))  );
			
			px_get_dot(px_cnvs,x1+w_x,y1+w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1+w_x,y1+w_y,r,g,b);

			px_get_dot(px_cnvs,x1-w_x,y1-w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1-w_x,y1-w_y,r,g,b);

			px_get_dot(px_cnvs,x1+w_x,y1-w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1+w_x,y1-w_y,r,g,b);

			px_get_dot(px_cnvs,x1-w_x,y1+w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1-w_x,y1+w_y,r,g,b);
			
			w_x=w_x+0.005;
		}
	}else{
		//縦に長い
		double w_x,w_y;
		w_y=0.4;
		while(w_y < lb){
			RGB_DOT w_rgb;
			w_x = (la/lb) * sqrt( (pow(lb,2.0)-pow(w_y,2.0))  );
			
			
			px_get_dot(px_cnvs,x1+w_x,y1+w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1+w_x,y1+w_y,r,g,b);

			px_get_dot(px_cnvs,x1-w_x,y1-w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1-w_x,y1-w_y,r,g,b);

			px_get_dot(px_cnvs,x1+w_x,y1-w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1+w_x,y1-w_y,r,g,b);

			px_get_dot(px_cnvs,x1-w_x,y1+w_y,&w_rgb);
			if (w_rgb.r !=now_rgb.r || w_rgb.g != now_rgb.g || w_rgb.b != now_rgb.b )
				px_dot(px_cnvs,x1-w_x,y1+w_y,r,g,b);
			w_y=w_y+0.005;
		}
	}
}
int px_paint(int x,int y,int r,int g,int b){
	RGB_DOT old_rgb;
	DOT* 	dot_stk;
	dot_stk = g_malloc(sizeof(DOT)*100000);
	if(dot_stk==NULL)printf("error px_paint\n");
	int 	dot_stk_p=0;
	px_get_dot(px_cnvs,x,y,&old_rgb);//塗りつぶす古い色を取り出す。
	if(old_rgb.r==r && old_rgb.g==g && old_rgb.b==b){g_free(dot_stk);return -1;}
	dot_stk[dot_stk_p].x=x;//開始位置をプッシュする。
	dot_stk[dot_stk_p].y=y;
	dot_stk_p++;
//g_print("塗りつぶす古い色 r:%d,g:%d,b:%d x:%d,y:%d\n",old_rgb.r,old_rgb.g,old_rgb.b,x,y);	
	while(dot_stk_p!=0){
		RGB_DOT w_cl,w_cl_vtl,upper_cl,down_cl,upper_cl_vtl,down_cl_vtl;//開始位置をポップする。
		dot_stk_p--;
		int w_x=dot_stk[dot_stk_p].x; 
		int w_y=dot_stk[dot_stk_p].y;
		int upper_fg2=FALSE;
		int down_fg=FALSE;

		
//g_print("左端まで、移動の前 x:%d,y:%d\n",w_x,w_y);
		//左端まで、移動。
		px_get_dot(px_cnvs,w_x,w_y,&w_cl);
		while(
			old_rgb.r==w_cl.r &&
			old_rgb.g==w_cl.g &&
			old_rgb.b==w_cl.b			
			){w_x--;px_get_dot(px_cnvs,w_x,w_y,&w_cl);
//g_print("左端まで、移動 x:%d,y:%d\n",w_x,w_y);
		     }
		w_x++;//左端
		//右に向かって
//g_print("右に向かって1 x:%d,y:%d\n",w_x,w_y);
		//今の位置と上と下の色を見る。
		px_get_dot(px_cnvs,w_x,w_y  ,&w_cl);//今の位置の色を見る
		px_get_dot(px_cnvs_vtl,w_x,w_y  ,&w_cl_vtl);//今の位置の色を見る
		px_get_dot(px_cnvs,w_x,w_y-1,&upper_cl);//上の色を見る
		px_get_dot(px_cnvs,w_x,w_y-1,&upper_cl_vtl);//上の色を見る
		px_get_dot(px_cnvs,w_x,w_y+1,&down_cl);//下の色を見る
		px_get_dot(px_cnvs,w_x,w_y+1,&down_cl_vtl);//下の色を見る
		while(	old_rgb.r==w_cl.r &&
				old_rgb.g==w_cl.g &&
				old_rgb.b==w_cl.b){
//g_print("右に向かって2 x:%d,y:%d\n",w_x,w_y);
		
			if (old_rgb.r==upper_cl.r && old_rgb.g==upper_cl.g && old_rgb.b==upper_cl.b ){//上の色と古い色がマッチした時
//g_print("上の色と古い色がマッチ x:%d,y:%d\n",w_x,w_y);
				if (upper_fg2==FALSE){//if(upper_cl_vtl.r==255 && upper_cl_vtl.g==255 && upper_cl_vtl.b==255 ){
//g_print("//開始位置をプッシュする。 x:%d,y:%d\n",w_x,w_y);
					
					dot_stk[dot_stk_p].x=w_x;//開始位置をプッシュする。
					dot_stk[dot_stk_p].y=w_y-1;
					dot_stk_p++;
					upper_fg2=TRUE;
				}
			}else {upper_fg2=FALSE;}
			if (old_rgb.r==down_cl.r && old_rgb.g==down_cl.g &&	old_rgb.b==down_cl.b){//下の色と古い色がマッチした時
//g_print("下の色と古い色がマッチ x:%d,y:%d\n",w_x,w_y);
				if (down_fg==FALSE){ //if( down_cl_vtl.r==255 && down_cl_vtl.g==255 && down_cl_vtl.b==255 ){
//g_print("//開始位置をプッシュする。 x:%d,y:%d\n",w_x,w_y);
					dot_stk[dot_stk_p].x=w_x;//開始位置をプッシュする。
					dot_stk[dot_stk_p].y=w_y+1;
					dot_stk_p++;
					down_fg=TRUE;
				} 
			}else down_fg=FALSE;
			px_dot(px_cnvs,w_x,w_y  ,r,g,b);//今の位置px_cnvsドットを打つ
			px_dot(px_cnvs_vtl,w_x,w_y  ,r,g,b);//今の位置px_cnvs_vtlドットを打つ
					
		
		//今の位置と上と下の色を見る。
			w_x++;	
			px_get_dot(px_cnvs,w_x,w_y  ,&w_cl);//今の位置の色を見る
			px_get_dot(px_cnvs_vtl,w_x,w_y  ,&w_cl_vtl);//今の位置の色を見る
			px_get_dot(px_cnvs,w_x,w_y-1,&upper_cl);//上の色を見る
			px_get_dot(px_cnvs,w_x,w_y-1,&upper_cl_vtl);//上の色を見る
			px_get_dot(px_cnvs,w_x,w_y+1,&down_cl);//下の色を見る
			px_get_dot(px_cnvs,w_x,w_y+1,&down_cl_vtl);//下の色を見る

		}
	}
	g_free(dot_stk);
}


int px_draw_repaint(){
	int gr_x,gr_y;
	gr_x=0;
	gr_y=0;
	while(gr_y<mv_size_heigth){
		gr_x=0;
		while(gr_x<mv_size_widht){
			if(	px_cnvs_vtl[gr_y*mv_size_widht+gr_x].r==255 &&
				px_cnvs_vtl[gr_y*mv_size_widht+gr_x].g==255 &&
				px_cnvs_vtl[gr_y*mv_size_widht+gr_x].b==255 ){}else{

				if (px_cnvs[gr_y*mv_size_widht+gr_x].r == px_cnvs_vtl[gr_y*mv_size_widht+gr_x].r &&
					px_cnvs[gr_y*mv_size_widht+gr_x].g == px_cnvs_vtl[gr_y*mv_size_widht+gr_x].g &&
					px_cnvs[gr_y*mv_size_widht+gr_x].b == px_cnvs_vtl[gr_y*mv_size_widht+gr_x].b){}
				else{
					px_dot(px_cnvs,gr_x,gr_y,
						px_cnvs[gr_y*mv_size_widht+gr_x].r,
						px_cnvs[gr_y*mv_size_widht+gr_x].g,
						px_cnvs[gr_y*mv_size_widht+gr_x].b);
					px_dot(px_cnvs,gr_x,gr_y,
						px_cnvs[gr_y*mv_size_widht+gr_x].r,
						px_cnvs[gr_y*mv_size_widht+gr_x].g,
						px_cnvs[gr_y*mv_size_widht+gr_x].b);
					/*px_dot(px_cnvs,gr_x,gr_y,
						px_cnvs[gr_y*mv_size_widht+gr_x].r,
						px_cnvs[gr_y*mv_size_widht+gr_x].g,
						px_cnvs[gr_y*mv_size_widht+gr_x].b);*/
				}
				px_cnvs_vtl[gr_y*mv_size_widht+gr_x].r=255;
				px_cnvs_vtl[gr_y*mv_size_widht+gr_x].g=255;
				px_cnvs_vtl[gr_y*mv_size_widht+gr_x].b=255;
			}
			gr_x=gr_x+1;
		}
		gr_y=gr_y+1;
	}
	//px_draw_full();
}

int px_draw_full(){
	int gr_x,gr_y;
	gr_x=0;
	gr_y=0;
	px_get_now_adjustment();
	while(gr_y<mv_size_heigth){
		gr_x=0;
		while(gr_x<mv_size_widht){
		
		
			if(	px_cnvs[gr_y*mv_size_widht+gr_x].r==255 &&
				px_cnvs[gr_y*mv_size_widht+gr_x].g==255 &&
				px_cnvs[gr_y*mv_size_widht+gr_x].b==255 ){}else{		
		
		
				px_dot(px_cnvs,gr_x,gr_y,
					px_cnvs[gr_y*mv_size_widht+gr_x].r,
					px_cnvs[gr_y*mv_size_widht+gr_x].g,
					px_cnvs[gr_y*mv_size_widht+gr_x].b);
			}
			gr_x=gr_x+1;
		}
		gr_y=gr_y+1;
	}
	
}

int cnvs_claer_full(){
	int x,y;
	y=0;
	while(y<mv_size_heigth){
		x=0;
		while(x<mv_size_widht){
			px_cnvs[y*mv_size_widht+x].r=255;
			px_cnvs[y*mv_size_widht+x].g=255;
			px_cnvs[y*mv_size_widht+x].b=255;

			px_cnvs_vtl[y*mv_size_widht+x].r=255;
			px_cnvs_vtl[y*mv_size_widht+x].g=255;
			px_cnvs_vtl[y*mv_size_widht+x].b=255;
			x++;
		}
		y++;
	}
}

void px_get_nowtool_str(char *str){
	if (now_tool==1)
		strcpy(str,"点");
	else if(now_tool==2)
		strcpy(str,"線");
	else if(now_tool==3)
		strcpy(str,"正方形");
	else if(now_tool==4)
		strcpy(str,"長方形");
	else if(now_tool==5)
		strcpy(str,"丸");
	else if(now_tool==6)
		strcpy(str,"楕円");
	else if(now_tool==7)
		strcpy(str,"塗り");
	else if(now_tool==9)
		strcpy(str,"スポイト");
}

void px_get_now_adjustment(){
	GtkAdjustment* w_ha,*w_va;
	
	w_ha = gtk_scrolled_window_get_hadjustment (g_scroll_window);
	w_va = gtk_scrolled_window_get_vadjustment (g_scroll_window);
	
	/*w_ha = gtk_scrollable_get_hadjustment (g_scroll_window);
	w_va = gtk_scrollable_get_vadjustment (g_scroll_window);*/
	
	now_window_left = (int)gtk_adjustment_get_value (w_ha)/dot_size;
	//now_window_right = (int)gtk_adjustment_get_lower (w_ha); 
	
	now_window_top = (int)gtk_adjustment_get_value (w_va)/dot_size;
	//now_window_bottom = (int)gtk_adjustment_get_lower (w_va);

gtk_window_get_size (window,
                     &now_window_right,
                     &now_window_bottom);

	now_window_right = (now_window_right-3)/dot_size+now_window_left;
	now_window_bottom = (now_window_bottom-27)/dot_size+now_window_top;
	 
	
/*	GtkWidget *w_hs,*w_vs;
	w_hs = gtk_scrolled_window_get_hscrollbar (g_scroll_window);
	w_vs = gtk_scrolled_window_get_vscrollbar (g_scroll_window);
	
	w_ha = gtk_range_get_adjustment (w_hs);
	

	w_va = gtk_range_get_adjustment (w_vs);
	
*/
	
}

gint motion_notify_event(GtkWidget* widget,GdkEventMotion* event){
	char str[1024];
	char str2[1024];
	static int old_x=0,old_y=0;
	if (tz>600){tz=0;px_draw_full();}else{tz++;}
//	int mouse_x, mouse_y;
//	SDL_GetMouseState(&mouse_x, &mouse_y);
//	if ((int)(event->x)!=mouse_x)return TRUE;
//	if ((int)(event->y)!=mouse_y)return TRUE;
	
	if (old_x==(int)(event->x)/dot_size && old_y==(int)(event->y)/dot_size ){return TRUE;}else {old_x=(int)(event->x)/dot_size;old_y=(int)(event->y)/dot_size;}

	gdk_window_clear(statas_area->window);

	cairo_t *cr;

	
	cr = gdk_cairo_create(statas_area->window);
	
	
	cairo_set_font_size(cr,14);
	
	cairo_move_to(cr,1,18);
	
	px_get_now_adjustment();
	
	px_get_nowtool_str(str2);
	
	sprintf(str,"   ( X:%d , Y:%d ) %s  top:%d bottom:%d left:%d right:%d"
				,(int)(event->x)/dot_size,(int)(event->y)/dot_size,str2
				,now_window_top,now_window_bottom,now_window_left,now_window_right);
	
	cairo_show_text(cr,str);
	
	cairo_destroy(cr);
	
	
	if( (int)(px_old_x)/dot_size!=(int)(event->x)/dot_size || (int)(px_old_y)/dot_size!=(int)(event->y/dot_size) ){	
		if(now_tool==1){
			if(m_b_e==1){
				px_dot(px_cnvs,event->x/dot_size,event->y/dot_size,now_rgb.r,now_rgb.g,now_rgb.b);
				save_fg = TRUE;
			}else if(m_b_e==3){
				px_dot(px_cnvs,event->x/dot_size,event->y/dot_size,255,255,255);
				save_fg = TRUE;
			}
		}else if(now_tool==2){
			px_draw_repaint();
			if (tool_line_start==TRUE)
				px_line(px_cnvs_vtl,line_x, line_y,(int)(event->x/dot_size),(int)(event->y/dot_size),now_rgb.r,now_rgb.g,now_rgb.b);
		}else if(now_tool==3){
			px_draw_repaint();
			if(tool_box_start==TRUE){
				int w_x1,w_y1,w_x2,w_y2,wk,w,h,l,xf,yf;
				w_x1= box_x;
				w_y1= box_y;
				w_x2=(int)event->x/dot_size;
				w_y2=(int)event->y/dot_size;
				
				if (w_x1 > w_x2){
					xf=-1;
					wk   = w_x1;
					w_x1 = w_x2;
					w_x2 = wk;
				}else xf=1;
				if (w_y1 > w_y2){
					yf=-1;
					wk   = w_y1;
					w_y1 = w_y2;
					w_y2 = wk;
				}else yf=1;
				w = w_x2 - w_x1;
				h = w_y2 - w_y1;
				
				if (w<h)l=h;else l=w;
				
				px_box(px_cnvs_vtl, box_x, box_y,box_x  + l*xf, box_y + l*yf ,now_rgb.r,now_rgb.g,now_rgb.b);
			}
		}else if(now_tool==4){
			px_draw_repaint();
			if (tool_box_start==TRUE)
				px_box(px_cnvs_vtl,box_x, box_y,(int)(event->x/dot_size),(int)(event->y/dot_size),now_rgb.r,now_rgb.g,now_rgb.b);
		}else if(now_tool==5){
			px_draw_repaint();
			if (tool_circle_start==TRUE){
				int w_x2,w_y2,la,lb,l;
				w_x2=(int)(event->x/dot_size);
				w_y2=(int)(event->y/dot_size);
				la=(double)get_l(box_x,w_x2);
				lb=(double)get_l(box_y,w_y2);
				if (la<lb)l=lb;else l=la;
				px_circle(px_cnvs_vtl, box_x, box_y, box_x+l, box_y+l,now_rgb.r,now_rgb.g,now_rgb.b);
				//px_circle(px_cnvs_vtl,box_x, box_y,(int)(event->x/dot_size),(int)(event->y/dot_size),now_rgb.r,now_rgb.g,now_rgb.b);
			}
		}else if(now_tool==6){
			px_draw_repaint();
			if (tool_circle_start==TRUE)
				px_circle(px_cnvs_vtl,box_x, box_y,(int)(event->x/dot_size),(int)(event->y/dot_size),now_rgb.r,now_rgb.g,now_rgb.b);
		}
	}
	px_old_x=(int)event->x;
	px_old_y=(int)event->y;
	
	return TRUE;
}

gboolean button_press_event(GtkWidget* widget,GdkEventButton* event, gpointer user_data){
	m_b_e=event->button;
	if (px_cnvs,event->x/dot_size >= mv_size_widht)return;
	if (px_cnvs,event->y/dot_size >= mv_size_heigth)return;
	
	
	if (now_tool==1){//----- 点 -----
		if(m_b_e==1){
			px_dot(px_cnvs,event->x/dot_size,event->y/dot_size,now_rgb.r,now_rgb.g,now_rgb.b);
			save_fg = TRUE;
		}else if(m_b_e==3){
			px_dot(px_cnvs,event->x/dot_size,event->y/dot_size,255,255,255);
			save_fg = TRUE;
		}
	}else if (now_tool==2){//----- 線 -----
		if(m_b_e==1){
			if (tool_line_start==FALSE){
				tool_line_start=TRUE;//１回目のクリック
				line_x=(int)(event->x/dot_size);
				line_y=(int)(event->y/dot_size);
			}else if(tool_line_start==TRUE){
				px_line(px_cnvs, line_x, line_y, (int)(event->x)/dot_size, (int)(event->y)/dot_size,now_rgb.r,now_rgb.g,now_rgb.b);
				save_fg = TRUE;
				tool_line_start=FALSE;//２回目のクリック
			}
		}else if(m_b_e==3){
			tool_line_start=FALSE;
		}
	}else if (now_tool==3){//----- 正方形 -----
		if(m_b_e==1){
			if (tool_box_start==FALSE){
				tool_box_start=TRUE;//１回目のクリック
				box_x=(int)(event->x/dot_size);
				box_y=(int)(event->y/dot_size);
			}else if(tool_box_start==TRUE){
				int w_x1,w_y1,w_x2,w_y2,wk,w,h,l,xf,yf;
				tool_box_start = FALSE;
				w_x1= box_x;
				w_y1= box_y;
				w_x2=(int)event->x/dot_size;
				w_y2=(int)event->y/dot_size;
				
				if (w_x1 > w_x2){
					xf=-1;
					wk   = w_x1;
					w_x1 = w_x2;
					w_x2 = wk;
				}else xf=1;
				if (w_y1 > w_y2){
					yf=-1;
					wk   = w_y1;
					w_y1 = w_y2;
					w_y2 = wk;
				}else yf=1;
				w = w_x2 - w_x1;
				h = w_y2 - w_y1;
				
				if (w<h)l=h;else l=w;
				
				px_box(px_cnvs, box_x, box_y,box_x  + l*xf, box_y + l*yf ,now_rgb.r,now_rgb.g,now_rgb.b);
				save_fg = TRUE;
			}
		}else if(m_b_e==3){
			tool_box_start=FALSE;
		}		
	}else if (now_tool==4){//----- 長方形 -----
		if(m_b_e==1){
			if (tool_box_start==FALSE){
				tool_box_start=TRUE;//１回目のクリック
				box_x=(int)(event->x/dot_size);
				box_y=(int)(event->y/dot_size);
			}else if(tool_box_start==TRUE){
				px_box(px_cnvs, box_x, box_y, (int)(event->x)/dot_size, (int)(event->y)/dot_size,now_rgb.r,now_rgb.g,now_rgb.b);
				tool_box_start=FALSE;//２回目のクリック
				save_fg = TRUE;
			}
		}else if(m_b_e==3){
			tool_box_start=FALSE;
		}		
	}else if (now_tool==5){//------ 円 -----
		if(m_b_e==1){
			//px_draw_repaint();
			if (tool_circle_start==FALSE){
				tool_circle_start=TRUE;//１回目のクリック
				box_x=(int)(event->x/dot_size);
				box_y=(int)(event->y/dot_size);
			}else if(tool_circle_start==TRUE){
				int w_x2,w_y2,la,lb,l;
				w_x2=(int)(event->x)/dot_size;
				w_y2=(int)(event->y)/dot_size;
				la=(double)get_l(box_x,w_x2);
				lb=(double)get_l(box_y,w_y2);
				if (la<lb)l=lb;else l=la;
				
				px_circle(px_cnvs, box_x, box_y,box_x +l,box_y +l,now_rgb.r,now_rgb.g,now_rgb.b);
				save_fg = TRUE;
				tool_circle_start=FALSE;//２回目のクリック
			}
		}else if(m_b_e==3){
			tool_circle_start=FALSE;
		}
	}else if (now_tool==6){//------ 楕円 -----
		if(m_b_e==1){
			//px_draw_repaint();
			if (tool_circle_start==FALSE){
				tool_circle_start=TRUE;//１回目のクリック
				box_x=(int)(event->x/dot_size);
				box_y=(int)(event->y/dot_size);
			}else if(tool_circle_start==TRUE){
				px_circle(px_cnvs, box_x, box_y, (int)(event->x)/dot_size, (int)(event->y)/dot_size,now_rgb.r,now_rgb.g,now_rgb.b);
				save_fg = TRUE;
				tool_circle_start=FALSE;//２回目のクリック
			}
		}else if(m_b_e==3){
			tool_circle_start=FALSE;
		}
	}else if (now_tool==7){//------ 塗 -----
		if(m_b_e==1){
		g_print("start paint\n");
			px_paint((int)(event->x/dot_size),(int)(event->y/dot_size),now_rgb.r,now_rgb.g,now_rgb.b);
			save_fg = TRUE;
			px_draw_repaint();
		}
	}else if (now_tool==9){//------ スポイト -----
		if(m_b_e==1){
		g_print("start spoit\n");
			px_get_dot(px_cnvs,(int)(event->x/dot_size),(int)(event->y/dot_size)  ,&now_rgb);
			px_draw_repaint();
		}
	}
g_print("now_tool%d\n",now_tool);
}

gboolean button_release_event(GtkWidget* widget,GdkEventButton* event, gpointer user_data){
	m_b_e=event->button*-1;
	if (now_tool==1){
		
	}
}

gboolean Main_View_Draw(GtkWidget* widget,GdkEventExpose* event,gpointer data){
//	px_draw_repaint();
	px_draw_full();
g_print("Main_View_Draw\n");	
	return FALSE;
}

gint delete_event(GtkWidget* widget,GdkEvent* event, gpointer data){
	g_print("delete_event 日本語表示テスト\n");
	if ( save_fg == TRUE){
		
	}
	return FALSE;
}

void destroy(GtkWidget* widget,gpointer data){
	//if (save_fg==TRUE){yesno_dialog();}
	g_print("destroy\n");
	//gtk_main_quit();
}

void px_error(char *str){
	gdk_window_clear(statas_area->window);

	cairo_t *cr;

	
	cr = gdk_cairo_create(statas_area->window);
	
	
	cairo_set_font_size(cr,14);
	
	cairo_move_to(cr,1,18);
	
	cairo_show_text(cr,str);
	
	cairo_destroy(cr);

}

int crate_main_window(){
	char str[1024];
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	strcpy(str,NOW_APP_NAME);
	strcat(str,":");
	strcat(str,now_file_name);
	char w_str[1024];
	sprintf(w_str,"  ( %d x %d )",mv_size_widht,mv_size_heigth);
	strcat(str,w_str);
	gtk_window_set_title(GTK_WINDOW(window),str);




	//gtk_window_set_title(GTK_WINDOW(window),"pixe 0.00");
gtk_window_set_default_icon_from_file("./スマイリーno074.png",NULL);	
	gtk_window_set_default_size(GTK_WINDOW(window),dot_size*64+3,dot_size*64+24+3);
	gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER_ALWAYS);
//	gtk_signal_connect(GTK_OBJECT(window),"delete_event",GTK_SIGNAL_FUNC(delete_event),NULL);
	gtk_signal_connect(GTK_OBJECT(window),"delete_event",G_CALLBACK(cb_quit),NULL);

	gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC(destroy),NULL);
	/*GtkUIManager *ui;
	GtkWidget	*menubar;*/
	GtkWidget	*menubar;
	GtkWidget	*vbox;
	
	vbox=gtk_vbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(window),vbox);

	menubar = create_menu ();
	//gtk_container_add (GTK_CONTAINER(window), menubar);
	/*ui=create_menu(window);
	g_object_set_data( G_OBJECT(window),"ui",(gpointer)ui);
	menubar=gtk_ui_manager_get_widget(ui,"/Menuber");*/
	gtk_box_pack_start(GTK_BOX(vbox),menubar,FALSE,FALSE,0);
	
	

	
	
	drawing_area=gtk_drawing_area_new();
	gtk_widget_set_size_request(drawing_area,dot_size*mv_size_widht,dot_size*mv_size_heigth);
//	gtk_container_add(GTK_CONTAINER(window),drawing_area);


	g_scroll_window = gtk_scrolled_window_new(NULL,NULL);
	
                                       


	gtk_box_pack_start(GTK_BOX(vbox),g_scroll_window,TRUE,TRUE,0);
//	gtk_box_pack_start(GTK_BOX(vbox),drawing_area,FALSE,FALSE,0);

	gtk_scrolled_window_set_policy (g_scroll_window,GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);

	gtk_scrolled_window_add_with_viewport (g_scroll_window,
                                       drawing_area);



	g_signal_connect(G_OBJECT(drawing_area),"expose_event",G_CALLBACK(Main_View_Draw),NULL);

	gtk_signal_connect(GTK_OBJECT(drawing_area),"motion_notify_event",(GtkSignalFunc)motion_notify_event,NULL);
	gtk_signal_connect(GTK_OBJECT(drawing_area),"button_press_event",(GtkSignalFunc)button_press_event,NULL);
	gtk_signal_connect(GTK_OBJECT(drawing_area),"button_release_event",(GtkSignalFunc)button_release_event,NULL);
	
	gtk_widget_set_events(drawing_area,
					GDK_POINTER_MOTION_MASK |
					GDK_ENTER_NOTIFY_MASK | 
					GDK_BUTTON_PRESS_MASK|
					GDK_BUTTON_RELEASE_MASK);
					
	//gtk_container_add(GTK_CONTAINER(window),menubar);
	
	//gtk_signal_connect(GTK_OBJECT(drawing_area),"enter_notiy_event",(GtkSignalFunc)enter_notiy_event,NULL);

	statas_area=gtk_drawing_area_new();
	gtk_widget_set_size_request(statas_area,dot_size*64,24);
//	gtk_container_add(GTK_CONTAINER(window),drawing_area);
	gtk_box_pack_start(GTK_BOX(vbox),statas_area,FALSE,FALSE,0);


	
	px_main_window=window;


	gtk_widget_show_all(window);
g_print("creat_main_view\n");	
}

int main(int argc,char* argv[]){
	gtk_set_locale();
	gtk_init(&argc, &argv);

	px_cnvs= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
	if(px_cnvs==NULL)printf("error main\n");
	px_cnvs_vtl= (RGB_DOT*)g_malloc( ( sizeof(RGB_DOT) * mv_size_widht * sizeof(RGB_DOT)*mv_size_heigth) );
	if(px_cnvs_vtl==NULL)printf("error main\n");

	cnvs_claer_full();

	strcpy(now_file_name,"無題1.doty");
	crate_main_window();
	create_tool_bar();
	create_color_palet();
	tool_bar_view_fg=TRUE;
	color_paret_view_fg=TRUE;
	save_fg=FALSE;
	if (argc==2){
		px_open(argv[1]);
	}
	strcpy(now_file_name,"無題1.doty");

	//gtk_widget_set_parent_window(cp_main_window,GTK_WINDOW(px_main_window));
	//gtk_widget_set_parent_window(tool_bar_window,GTK_WINDOW(px_main_window));
	//gtk_widget_set_parent(tool_bar_window,px_main_window);
	gtk_main();
	return 0;
}





